 GNU assembler version 2.21 (propeller-elf)
	 using BFD version (propellergcc_v1_0_0_2408) 2.21.
 options passed	: -lmm -ahdlnsg=lmm/RAM_Test.asm 
 input file    	: C:\Users\mikeo\AppData\Local\Temp\ccbBPzBk.s
 output file   	: lmm/RAM_Test.o
 target        	: propeller-parallax-elf
 time stamp    	: 

   1              		.text
   2              	.Ltext0
   3              		.balign	4
   4              		.global	_init_RAM
   5              	_init_RAM
   6              	.LFB2
   7              		.file 1 "RAM_Test.c"
   1:RAM_Test.c    **** #include "simpletools.h"
   2:RAM_Test.c    **** #include "propeller.h"
   3:RAM_Test.c    **** 
   4:RAM_Test.c    **** /*  Do not use row 0 as address 0 is written to 0 at the beginning of each write cycle
   5:RAM_Test.c    ****  *  CY62256N
   6:RAM_Test.c    ****  *  256-Kbit (32 K × 8) SRAM
   7:RAM_Test.c    ****  *  70ns
   8:RAM_Test.c    ****  *  Propeller Flip rev.a
   9:RAM_Test.c    ****  *  P0-7 = I/O 0-7
  10:RAM_Test.c    ****  *  P8   = WE write enable  active low
  11:RAM_Test.c    ****  *  P9   = OE output enable active low
  12:RAM_Test.c    ****  *  P10  = A0  = C0
  13:RAM_Test.c    ****  *  P11  = A1  = C1
  14:RAM_Test.c    ****  *  P12  = A11 = C2
  15:RAM_Test.c    ****  *  P13  = A12 = C3
  16:RAM_Test.c    ****  *  P14  = A13 = C4
  17:RAM_Test.c    ****  *  P15  = A14 = C5
  18:RAM_Test.c    ****  *  P16  = A2  = R0
  19:RAM_Test.c    ****  *  P17  = A3  = R1
  20:RAM_Test.c    ****  *  P18  = A4  = R2
  21:RAM_Test.c    ****  *  P19  = A5  = R3
  22:RAM_Test.c    ****  *  P20  = A6  = R4
  23:RAM_Test.c    ****  *  P21  = A7  = R5
  24:RAM_Test.c    ****  *  P22  = A8  = R6
  25:RAM_Test.c    ****  *  P23  = A9  = R7
  26:RAM_Test.c    ****  *  P24  = A10 = R8
  27:RAM_Test.c    ****  *  P25  = CE chip enable   active low
  28:RAM_Test.c    ****  */
  29:RAM_Test.c    **** 
  30:RAM_Test.c    **** void init_RAM();
  31:RAM_Test.c    **** void open_write();
  32:RAM_Test.c    **** void close_write();
  33:RAM_Test.c    **** void open_read();
  34:RAM_Test.c    **** void close_read();
  35:RAM_Test.c    **** void write_byte(int32_t byte_out, uint32_t address);
  36:RAM_Test.c    **** int32_t read_byte(uint32_t address);
  37:RAM_Test.c    **** void read_row(int32_t array_in, uint32_t row);
  38:RAM_Test.c    **** 
  39:RAM_Test.c    **** int main() {                  // Entry point
  40:RAM_Test.c    ****   init_RAM();
  41:RAM_Test.c    ****   open_write();       // Open write
  42:RAM_Test.c    ****   int32_t j, start, end, reg, data[64];
  43:RAM_Test.c    ****  
  44:RAM_Test.c    ****   j = 0;
  45:RAM_Test.c    ****   while(j < 16) {
  46:RAM_Test.c    ****     data[j] = 0;
  47:RAM_Test.c    ****     j++;
  48:RAM_Test.c    ****   }     
  49:RAM_Test.c    ****   
  50:RAM_Test.c    ****   j = 0;
  51:RAM_Test.c    ****   start = CNT;        // Start timing write byte
  52:RAM_Test.c    ****   while(j < 32768) {
  53:RAM_Test.c    ****     write_byte(j, j); // Write byte
  54:RAM_Test.c    ****     j++;
  55:RAM_Test.c    ****   }
  56:RAM_Test.c    ****   end = CNT;          // Stop timing write byte
  57:RAM_Test.c    ****   print("%d random byte writes per second\n", CLKFREQ / ((end-start) / 32768));    
  58:RAM_Test.c    ****   close_write();      // Close write
  59:RAM_Test.c    ****   
  60:RAM_Test.c    ****   open_read();
  61:RAM_Test.c    ****   j = 0;
  62:RAM_Test.c    ****   while(j < 511) {
  63:RAM_Test.c    ****     print("%d: %d\n", j, read_byte(j));
  64:RAM_Test.c    ****     j++;
  65:RAM_Test.c    ****   }
  66:RAM_Test.c    ****   
  67:RAM_Test.c    ****   j = 0;
  68:RAM_Test.c    ****   start = CNT;        // Start timing read byte 
  69:RAM_Test.c    ****   while(j < 32768) {
  70:RAM_Test.c    ****     reg = read_byte(j); // Read byte and store in reg
  71:RAM_Test.c    ****     j++;
  72:RAM_Test.c    ****   }
  73:RAM_Test.c    ****   end = CNT;          // Stop timing read byte
  74:RAM_Test.c    ****   close_read(); 
  75:RAM_Test.c    ****    
  76:RAM_Test.c    ****   print("%d random byte reads per second\n", CLKFREQ / ((end-start) / 32768)); 
  77:RAM_Test.c    **** 
  78:RAM_Test.c    **** 
  79:RAM_Test.c    ****     j=0;
  80:RAM_Test.c    ****     open_read();      // Open read
  81:RAM_Test.c    ****     start = CNT;      // Start timing read row
  82:RAM_Test.c    ****     while(j < 64) {
  83:RAM_Test.c    ****       read_row(data, j);  // Read row
  84:RAM_Test.c    ****       j++;
  85:RAM_Test.c    ****     }      
  86:RAM_Test.c    ****     end = CNT;        // Stop timing read row
  87:RAM_Test.c    ****     close_read();     // Close read
  88:RAM_Test.c    **** 
  89:RAM_Test.c    ****     
  90:RAM_Test.c    ****   j = 0;
  91:RAM_Test.c    ****   while(j < 64) {
  92:RAM_Test.c    ****     print("%d\n", ((uint8_t *)(data))[j]);
  93:RAM_Test.c    ****     j++;
  94:RAM_Test.c    ****   }
  95:RAM_Test.c    ****   
  96:RAM_Test.c    ****   print("%d sequential byte reads per second\n", CLKFREQ / ((end-start) / 4096));    
  97:RAM_Test.c    ****    
  98:RAM_Test.c    **** }
  99:RAM_Test.c    **** 
 100:RAM_Test.c    **** 
 101:RAM_Test.c    **** void init_RAM() {
   8              		.loc 1 101 0
 102:RAM_Test.c    ****   DIRA |= (262143 << 8);      // Set address and control bits to outgoing
   9              		.loc 1 102 0
  10 0000 0000BCA0 		mov	r7, DIRA
  11              	.LVL0
  12 0004 00007C5C 		mvi	r6,#67108608
  12      00FFFF03 
  13 000c 0000BC68 		or	r7, r6
  14              	.LVL1
  15 0010 0000BCA0 		mov	DIRA, r7
  16              	.LVL2
 103:RAM_Test.c    ****   OUTA &= ~67108863;          // Clear address, control, and bus bits
  17              		.loc 1 103 0
  18 0014 0000BCA0 		mov	r7, OUTA
  19              	.LVL3
  20 0018 00007C5C 		mvi	r6,#-67108864
  20      000000FC 
  21 0020 0000BC60 		and	r7, r6
  22              	.LVL4
  23 0024 0000BCA0 		mov	OUTA, r7
  24              	.LVL5
 104:RAM_Test.c    ****   OUTA |= (1 << 25);          // Raise CE to disable
  25              		.loc 1 104 0
  26 0028 0000BCA0 		mov	r7, OUTA
  27 002c 00007C5C 		mvi	r6,#33554432
  27      00000002 
  28 0034 0000BC68 		or	r7, r6
  29              	.LVL6
  30 0038 0000BCA0 		mov	OUTA, r7
  31              	.LVL7
 105:RAM_Test.c    ****   OUTA |= (1 << 8);           // Raise WE to prevent write
  32              		.loc 1 105 0
  33 003c 0000BCA0 		mov	r7, OUTA
  34 0040 0001FC68 		or	r7, #256
  35              	.LVL8
  36 0044 0000BCA0 		mov	OUTA, r7
  37              	.LVL9
 106:RAM_Test.c    ****   OUTA |= (1 << 9);           // Raise OE to prevent read
  38              		.loc 1 106 0
  39 0048 0000BCA0 		mov	r7, OUTA
  40 004c 00007C5C 		mvi	r6,#512
  40      00020000 
  41 0054 0000BC68 		or	r7, r6
  42              	.LVL10
  43 0058 0000BCA0 		mov	OUTA, r7
  44              	.LVL11
 107:RAM_Test.c    **** }
  45              		.loc 1 107 0
  46 005c 0000BCA0 		mov	pc,lr
  47              	.LFE2
  48              		.balign	4
  49              		.global	_open_write
  50              	_open_write
  51              	.LFB3
 108:RAM_Test.c    **** 
 109:RAM_Test.c    **** void open_write() {
  52              		.loc 1 109 0
 110:RAM_Test.c    ****   DIRA |= 255;                // Set bus to outgoing
  53              		.loc 1 110 0
  54 0060 0000BCA0 		mov	r7, DIRA
  55              	.LVL12
  56 0064 FF00FC68 		or	r7, #255
  57              	.LVL13
  58 0068 0000BCA0 		mov	DIRA, r7
  59              	.LVL14
 111:RAM_Test.c    ****   OUTA = (OUTA & 0xfe0003ff) | ((0 & 0x7fff) << 10);  // Clear address
  60              		.loc 1 111 0
  61 006c 0000BCA0 		mov	r7, OUTA
  62              	.LVL15
  63 0070 00007C5C 		mvi	r6,#-33553409
  63      FF0300FE 
  64 0078 0000BC60 		and	r7, r6
  65              	.LVL16
  66 007c 0000BCA0 		mov	OUTA, r7
  67              	.LVL17
 112:RAM_Test.c    ****   OUTA &= ~(1 << 25);         // Lower CE to enable
  68              		.loc 1 112 0
  69 0080 0000BCA0 		mov	r7, OUTA
  70 0084 00007C5C 		mvi	r6,#-33554433
  70      FFFFFFFD 
  71 008c 0000BC60 		and	r7, r6
  72              	.LVL18
  73 0090 0000BCA0 		mov	OUTA, r7
  74              	.LVL19
 113:RAM_Test.c    ****   OUTA &= ~(1 << 8);          // Lower WE to begin write sequence
  75              		.loc 1 113 0
  76 0094 0000BCA0 		mov	r7, OUTA
  77 0098 0001FC64 		andn	r7, #0x100
  78              	.LVL20
  79 009c 0000BCA0 		mov	OUTA, r7
  80              	.LVL21
 114:RAM_Test.c    **** }
  81              		.loc 1 114 0
  82 00a0 0000BCA0 		mov	pc,lr
  83              	.LFE3
  84              		.balign	4
  85              		.global	_close_write
  86              	_close_write
  87              	.LFB4
 115:RAM_Test.c    **** 
 116:RAM_Test.c    **** void close_write() {
  88              		.loc 1 116 0
 117:RAM_Test.c    ****   OUTA |= (1 << 8);           // Raise WE to end write sequence
  89              		.loc 1 117 0
  90 00a4 0000BCA0 		mov	r7, OUTA
  91              	.LVL22
  92 00a8 0001FC68 		or	r7, #256
  93              	.LVL23
  94 00ac 0000BCA0 		mov	OUTA, r7
  95              	.LVL24
 118:RAM_Test.c    ****   OUTA |= (1 << 25);          // Raise CE to disable
  96              		.loc 1 118 0
  97 00b0 0000BCA0 		mov	r7, OUTA
  98 00b4 00007C5C 		mvi	r6,#33554432
  98      00000002 
  99 00bc 0000BC68 		or	r7, r6
 100              	.LVL25
 101 00c0 0000BCA0 		mov	OUTA, r7
 102              	.LVL26
 119:RAM_Test.c    ****   OUTA &= ~255;               // Clear bus
 103              		.loc 1 119 0
 104 00c4 0000BCA0 		mov	r7, OUTA
 105 00c8 FF00FC64 		andn	r7, #0xff
 106              	.LVL27
 107 00cc 0000BCA0 		mov	OUTA, r7
 108              	.LVL28
 120:RAM_Test.c    **** }
 109              		.loc 1 120 0
 110 00d0 0000BCA0 		mov	pc,lr
 111              	.LFE4
 112              		.balign	4
 113              		.global	_write_byte
 114              	_write_byte
 115              	.LFB5
 121:RAM_Test.c    **** 
 122:RAM_Test.c    **** void write_byte(int32_t byte_out, uint32_t address) {
 116              		.loc 1 122 0
 117              	.LVL29
 123:RAM_Test.c    ****   OUTA = (OUTA & 0xfe0003ff) | ((address & 0x7fff) << 10);  // Input address
 118              		.loc 1 123 0
 119 00d4 00007C5C 		mvi	r6,#32767
 119      FF7F0000 
 120 00dc 0000BCA0 		mov	r7, OUTA
 121              	.LVL30
 122 00e0 0000BC60 		and	r1, r6
 123              	.LVL31
 124 00e4 00007C5C 		mvi	r6,#-33553409
 124      FF0300FE 
 125 00ec 0000BC60 		and	r7, r6
 126 00f0 0A00FC2C 		shl	r1, #10
 127              	.LVL32
 128 00f4 0000BC68 		or	r1, r7
 129              	.LVL33
 130 00f8 0000BCA0 		mov	OUTA, r1
 124:RAM_Test.c    ****   OUTA = (OUTA & 0xffffff00) | ((byte_out & 0xff) << 0);    // Write data Byte to bus
 131              		.loc 1 124 0
 132 00fc 0000BCA0 		mov	r7, OUTA
 133 0100 FF00FC60 		and	r0, #255
 134              	.LVL34
 135 0104 FF00FC64 		andn	r7, #0xff
 136 0108 0000BC68 		or	r0, r7
 137              	.LVL35
 138 010c 0000BCA0 		mov	OUTA, r0
 125:RAM_Test.c    **** }
 139              		.loc 1 125 0
 140 0110 0000BCA0 		mov	pc,lr
 141              	.LFE5
 142              		.balign	4
 143              		.global	_open_read
 144              	_open_read
 145              	.LFB6
 126:RAM_Test.c    **** 
 127:RAM_Test.c    **** void open_read() {
 146              		.loc 1 127 0
 128:RAM_Test.c    ****   DIRA &= ~255;               // Set bus to incoming
 147              		.loc 1 128 0
 148 0114 0000BCA0 		mov	r7, DIRA
 149              	.LVL36
 150 0118 FF00FC64 		andn	r7, #0xff
 151              	.LVL37
 152 011c 0000BCA0 		mov	DIRA, r7
 153              	.LVL38
 129:RAM_Test.c    ****   OUTA = (OUTA & 0xfe0003ff) | ((0 & 0x7fff) << 10);  // Clear address
 154              		.loc 1 129 0
 155 0120 0000BCA0 		mov	r7, OUTA
 156              	.LVL39
 157 0124 00007C5C 		mvi	r6,#-33553409
 157      FF0300FE 
 158 012c 0000BC60 		and	r7, r6
 159              	.LVL40
 160 0130 0000BCA0 		mov	OUTA, r7
 161              	.LVL41
 130:RAM_Test.c    ****   OUTA &= (~(1 << 25));       // Lower CE to enable
 162              		.loc 1 130 0
 163 0134 0000BCA0 		mov	r7, OUTA
 164 0138 00007C5C 		mvi	r6,#-33554433
 164      FFFFFFFD 
 165 0140 0000BC60 		and	r7, r6
 166              	.LVL42
 167 0144 0000BCA0 		mov	OUTA, r7
 168              	.LVL43
 131:RAM_Test.c    ****   OUTA &= (~(1 << 9));        // Lower OE to begin read sequence
 169              		.loc 1 131 0
 170 0148 0000BCA0 		mov	r7, OUTA
 171 014c 00007C5C 		mvi	r6,#-513
 171      FFFDFFFF 
 172 0154 0000BC60 		and	r7, r6
 173              	.LVL44
 174 0158 0000BCA0 		mov	OUTA, r7
 175              	.LVL45
 132:RAM_Test.c    **** }
 176              		.loc 1 132 0
 177 015c 0000BCA0 		mov	pc,lr
 178              	.LFE6
 179              		.balign	4
 180              		.global	_close_read
 181              	_close_read
 182              	.LFB7
 133:RAM_Test.c    **** 
 134:RAM_Test.c    **** void close_read() {
 183              		.loc 1 134 0
 135:RAM_Test.c    ****   OUTA |= (1 << 9);           // Raise OE to end read sequence
 184              		.loc 1 135 0
 185 0160 0000BCA0 		mov	r7, OUTA
 186              	.LVL46
 187 0164 00007C5C 		mvi	r6,#512
 187      00020000 
 188 016c 0000BC68 		or	r7, r6
 189              	.LVL47
 190 0170 0000BCA0 		mov	OUTA, r7
 191              	.LVL48
 136:RAM_Test.c    ****   OUTA |= (1 << 25);          // Raise CE to disable
 192              		.loc 1 136 0
 193 0174 0000BCA0 		mov	r7, OUTA
 194 0178 00007C5C 		mvi	r6,#33554432
 194      00000002 
 195 0180 0000BC68 		or	r7, r6
 196              	.LVL49
 197 0184 0000BCA0 		mov	OUTA, r7
 198              	.LVL50
 137:RAM_Test.c    ****   OUTA &= ~255;               // Clear bus
 199              		.loc 1 137 0
 200 0188 0000BCA0 		mov	r7, OUTA
 201 018c FF00FC64 		andn	r7, #0xff
 202              	.LVL51
 203 0190 0000BCA0 		mov	OUTA, r7
 204              	.LVL52
 138:RAM_Test.c    **** }
 205              		.loc 1 138 0
 206 0194 0000BCA0 		mov	pc,lr
 207              	.LFE7
 208              		.balign	4
 209              		.global	_read_byte
 210              	_read_byte
 211              	.LFB8
 139:RAM_Test.c    **** 
 140:RAM_Test.c    **** int32_t read_byte(uint32_t address) {
 212              		.loc 1 140 0
 213              	.LVL53
 141:RAM_Test.c    ****   int32_t result = 0;          
 142:RAM_Test.c    ****   OUTA = (OUTA & 0xfe0003ff) | ((address & 0x7fff) << 10);  // Input address
 214              		.loc 1 142 0
 215 0198 00007C5C 		mvi	r6,#32767
 215      FF7F0000 
 216 01a0 0000BCA0 		mov	r7, OUTA
 217              	.LVL54
 218 01a4 0000BC60 		and	r0, r6
 219              	.LVL55
 220 01a8 00007C5C 		mvi	r6,#-33553409
 220      FF0300FE 
 221 01b0 0000BC60 		and	r7, r6
 222 01b4 0A00FC2C 		shl	r0, #10
 223              	.LVL56
 224 01b8 0000BC68 		or	r0, r7
 225              	.LVL57
 226 01bc 0000BCA0 		mov	OUTA, r0
 143:RAM_Test.c    ****   result = INA & 0xff;        // Record data Byte from bus
 227              		.loc 1 143 0
 228 01c0 0000BCA0 		mov	r0, INA
 229              	.LVL58
 230 01c4 FF00FC60 		and	r0, #255
 231              	.LVL59
 144:RAM_Test.c    ****   return result;
 145:RAM_Test.c    **** }
 232              		.loc 1 145 0
 233 01c8 0000BCA0 		mov	pc,lr
 234              	.LFE8
 235              		.balign	4
 236              		.global	_read_row
 237              	_read_row
 238              	.LFB9
 146:RAM_Test.c    **** 
 147:RAM_Test.c    **** //Array by name, address of first byte, length in bytes
 148:RAM_Test.c    **** void read_row(int32_t array_in, uint32_t row) {    
 239              		.loc 1 148 0
 240              	.LVL60
 149:RAM_Test.c    ****   row = row<<6;
 241              		.loc 1 149 0
 242 01cc 0600FC2C 		shl	r1, #6
 243              	.LVL61
 150:RAM_Test.c    ****   for(int32_t i = 0; i < 64; i++) {
 244              		.loc 1 150 0
 245 01d0 0000FCA0 		mov	r6, #0
 246              	.LBB2
 151:RAM_Test.c    ****     OUTA = (OUTA & 0xfe0003ff) | (((row + i) & 0x7fff) << 10);    // Input address
 247              		.loc 1 151 0
 248 01d4 00007C5C 		mvi	r3,#32767
 248      FF7F0000 
 249 01dc 00007C5C 		mvi	r4,#-33553409
 249      FF0300FE 
 250              	.LVL62
 251 01e4 00007C5C 		jmp	#__LMM_FCACHE_LOAD
 252 01e8 40000000 		long	.L12-.L11
 253              	.L11
 254              	.L9
 148:RAM_Test.c    **** void read_row(int32_t array_in, uint32_t row) {    
 255              		.loc 1 148 0 discriminator 2
 256 01ec 0000BCA0 		mov	r7, r6
 257              	.LVL63
 258 01f0 0000BC80 		add	r7, r1
 259              	.LVL64
 260              		.loc 1 151 0 discriminator 2
 261 01f4 0000BCA0 		mov	r5, OUTA
 262 01f8 0000BC60 		and	r7, r3
 263              	.LVL65
 264 01fc 0000BC60 		and	r5, r4
 265 0200 0A00FC2C 		shl	r7, #10
 266              	.LVL66
 267 0204 0000BC68 		or	r7, r5
 268              	.LVL67
 269 0208 0000BCA0 		mov	OUTA, r7
 148:RAM_Test.c    **** void read_row(int32_t array_in, uint32_t row) {    
 270              		.loc 1 148 0 discriminator 2
 271 020c 0000BCA0 		mov	r7, r6
 272              	.LVL68
 152:RAM_Test.c    ****     ((uint8_t *)(array_in))[i] = INA & 0xff;                      // Record data Byte from bus
 273              		.loc 1 152 0 discriminator 2
 274 0210 0000BCA0 		mov	r5, INA
 148:RAM_Test.c    **** void read_row(int32_t array_in, uint32_t row) {    
 275              		.loc 1 148 0 discriminator 2
 276 0214 0000BC80 		add	r7, r0
 150:RAM_Test.c    ****   for(int32_t i = 0; i < 64; i++) {
 277              		.loc 1 150 0 discriminator 2
 278 0218 0100FC80 		add	r6, #1
 279              	.LVL69
 280 021c 40007CC3 		cmps	r6, #64 wz,wc
 281              		.loc 1 152 0 discriminator 2
 282 0220 00003C00 		wrbyte	r5, r7
 150:RAM_Test.c    ****   for(int32_t i = 0; i < 64; i++) {
 283              		.loc 1 150 0 discriminator 2
 284 0224 0000545C 		IF_NE	jmp	#__LMM_FCACHE_START+(.L9-.L11)
 285 0228 00003C5C 		jmp	__LMM_RET
 286              		.compress default
 287              	.L12
 288              	.LBE2
 153:RAM_Test.c    ****   } 
 154:RAM_Test.c    **** }...
 289              		.loc 1 154 0
 290 022c 0000BCA0 		mov	pc,lr
 291              	.LFE9
 292              		.data
 293              		.balign	4
 294              	.LC0
 295 0000 25642072 		.ascii "%d random byte writes per second\12\0"
 295      616E646F 
 295      6D206279 
 295      74652077 
 295      72697465 
 296 0022 0000     		.balign	4
 297              	.LC1
 298 0024 25643A20 		.ascii "%d: %d\12\0"
 298      25640A00 
 299              		.balign	4
 300              	.LC2
 301 002c 25642072 		.ascii "%d random byte reads per second\12\0"
 301      616E646F 
 301      6D206279 
 301      74652072 
 301      65616473 
 302 004d 000000   		.balign	4
 303              	.LC3
 304 0050 25640A00 		.ascii "%d\12\0"
 305              		.balign	4
 306              	.LC4
 307 0054 25642073 		.ascii "%d sequential byte reads per second\12\0"
 307      65717565 
 307      6E746961 
 307      6C206279 
 307      74652072 
 308 0079 000000   		.text
 309              		.balign	4
 310              		.global	_main
 311              	_main
 312              	.LFB1
  39:RAM_Test.c    **** int main() {                  // Entry point
 313              		.loc 1 39 0
 314 0230 5B00FCA0 		mov	__TMP0,#(5<<4)+11
 315 0234 0000FC5C 		call	#__LMM_PUSHM
 316              	.LCFI0
 317 0238 0C01FC84 		sub	sp, #268
 318              	.LCFI1
  40:RAM_Test.c    ****   init_RAM();
 319              		.loc 1 40 0
 320 023c 00007C5C 		lcall	#_init_RAM
 320      00000000 
  41:RAM_Test.c    ****   open_write();       // Open write
 321              		.loc 1 41 0
 322 0244 00007C5C 		lcall	#_open_write
 322      00000000 
 323              	.LVL70
 324 024c 0000FCA0 		mov	r7, #0
 325              	.LVL71
 326 0250 00007C5C 		jmp	#__LMM_FCACHE_LOAD
 327 0254 24000000 		long	.L27-.L26
 328              	.L26
 329              	.L14
  39:RAM_Test.c    **** int main() {                  // Entry point
 330              		.loc 1 39 0
 331 0258 0C00FCA0 		mov	r6, #12
 332 025c 0000BC80 		add	r6, sp
 333 0260 0000BC80 		add	r6, r7
  46:RAM_Test.c    ****     data[j] = 0;
 334              		.loc 1 46 0
 335 0264 0000FCA0 		mov	r5, #0
 336 0268 0400FC80 		add	r7, #4
  45:RAM_Test.c    ****   while(j < 16) {
 337              		.loc 1 45 0
 338 026c 40007CC3 		cmps	r7, #64 wz,wc
  46:RAM_Test.c    ****     data[j] = 0;
 339              		.loc 1 46 0
 340 0270 00003C08 		wrlong	r5, r6
  45:RAM_Test.c    ****   while(j < 16) {
 341              		.loc 1 45 0
 342 0274 0000545C 		IF_NE	jmp	#__LMM_FCACHE_START+(.L14-.L26)
 343 0278 00003C5C 		jmp	__LMM_RET
 344              		.compress default
 345              	.L27
 346              	.LVL72
  51:RAM_Test.c    ****   start = CNT;        // Start timing write byte
 347              		.loc 1 51 0
 348 027c 0000BCA0 		mov	r13, CNT
 349              	.LVL73
  50:RAM_Test.c    ****   j = 0;
 350              		.loc 1 50 0
 351 0280 0000FCA0 		mov	r14, #0
  52:RAM_Test.c    ****   while(j < 32768) {
 352              		.loc 1 52 0
 353 0284 00007C5C 		mvi	r12,#32768
 353      00800000 
 354              	.LVL74
 355              	.L15
  53:RAM_Test.c    ****     write_byte(j, j); // Write byte
 356              		.loc 1 53 0
 357 028c 0000BCA0 		mov	r0, r14
 358 0290 0000BCA0 		mov	r1, r14
  54:RAM_Test.c    ****     j++;
 359              		.loc 1 54 0
 360 0294 0100FC80 		add	r14, #1
  53:RAM_Test.c    ****     write_byte(j, j); // Write byte
 361              		.loc 1 53 0
 362 0298 00007C5C 		lcall	#_write_byte
 362      00000000 
 363              	.LVL75
  52:RAM_Test.c    ****   while(j < 32768) {
 364              		.loc 1 52 0
 365 02a0 00003CC3 		cmps	r14, r12 wz,wc
 366 02a4 1C00D484 		IF_NE	brs	#.L15
  56:RAM_Test.c    ****   end = CNT;          // Stop timing write byte
 367              		.loc 1 56 0
 368 02a8 0000BCA0 		mov	r0, CNT
 369              	.LVL76
  57:RAM_Test.c    ****   print("%d random byte writes per second\n", CLKFREQ / ((end-start) / 32768));    
 370              		.loc 1 57 0
 371 02ac 00007C5C 		mvi	r7,#.LC0
 371      00000000 
 372 02b4 0000BC84 		sub	r0, r13
 373              	.LVL77
 374 02b8 0000BCA0 		mov	r1, r14
 375 02bc 0000FC5C 		call	#__DIVSI
 376 02c0 00003C08 		wrlong	r7, sp
 377 02c4 00007C5C 		mvi	r7,#__clkfreq
 377      00000000 
 378 02cc 0000BCA0 		mov	r1, r0
 379 02d0 0000BCA0 		mov	r13, sp
 380              	.LVL78
 381 02d4 0400FC80 		add	r13, #4
  63:RAM_Test.c    ****     print("%d: %d\n", j, read_byte(j));
 382              		.loc 1 63 0
 383 02d8 0000BCA0 		mov	r12, sp
  61:RAM_Test.c    ****   j = 0;
 384              		.loc 1 61 0
 385 02dc 0000FCA0 		mov	r14, #0
 386              	.LVL79
  63:RAM_Test.c    ****     print("%d: %d\n", j, read_byte(j));
 387              		.loc 1 63 0
 388 02e0 0800FC80 		add	r12, #8
  57:RAM_Test.c    ****   print("%d random byte writes per second\n", CLKFREQ / ((end-start) / 32768));    
 389              		.loc 1 57 0
 390 02e4 0000BC08 		rdlong	r0, r7
 391 02e8 0000FC5C 		call	#__UDIVSI
 392 02ec 00003C08 		wrlong	r0, r13
 393 02f0 00007C5C 		lcall	#_print
 393      00000000 
  58:RAM_Test.c    ****   close_write();      // Close write
 394              		.loc 1 58 0
 395 02f8 00007C5C 		lcall	#_close_write
 395      00000000 
  60:RAM_Test.c    ****   open_read();
 396              		.loc 1 60 0
 397 0300 00007C5C 		lcall	#_open_read
 397      00000000 
 398              	.LVL80
 399              	.L16
  63:RAM_Test.c    ****     print("%d: %d\n", j, read_byte(j));
 400              		.loc 1 63 0
 401 0308 0000BCA0 		mov	r0, r14
 402 030c 00007C5C 		lcall	#_read_byte
 402      00000000 
 403 0314 00007C5C 		mvi	r5,#.LC1
 403      00000000 
 404 031c 00003C08 		wrlong	r5, sp
 405 0320 00003C08 		wrlong	r14, r13
  64:RAM_Test.c    ****     j++;
 406              		.loc 1 64 0
 407 0324 0100FC80 		add	r14, #1
  63:RAM_Test.c    ****     print("%d: %d\n", j, read_byte(j));
 408              		.loc 1 63 0
 409 0328 00003C08 		wrlong	r0, r12
 410 032c 00007C5C 		lcall	#_print
 410      00000000 
 411              	.LVL81
  62:RAM_Test.c    ****   while(j < 511) {
 412              		.loc 1 62 0
 413 0334 FF017CC3 		cmps	r14, #511 wz,wc
 414 0338 3400D484 		IF_NE	brs	#.L16
 415              	.LVL82
  68:RAM_Test.c    ****   start = CNT;        // Start timing read byte 
 416              		.loc 1 68 0
 417 033c 0000BCA0 		mov	r13, CNT
 418              	.LVL83
  67:RAM_Test.c    ****   j = 0;
 419              		.loc 1 67 0
 420 0340 0000FCA0 		mov	r14, #0
  69:RAM_Test.c    ****   while(j < 32768) {
 421              		.loc 1 69 0
 422 0344 00007C5C 		mvi	r12,#32768
 422      00800000 
 423              	.LVL84
 424              	.L17
  70:RAM_Test.c    ****     reg = read_byte(j); // Read byte and store in reg
 425              		.loc 1 70 0
 426 034c 0000BCA0 		mov	r0, r14
  71:RAM_Test.c    ****     j++;
 427              		.loc 1 71 0
 428 0350 0100FC80 		add	r14, #1
  70:RAM_Test.c    ****     reg = read_byte(j); // Read byte and store in reg
 429              		.loc 1 70 0
 430 0354 00007C5C 		lcall	#_read_byte
 430      00000000 
 431              	.LVL85
  69:RAM_Test.c    ****   while(j < 32768) {
 432              		.loc 1 69 0
 433 035c 00003CC3 		cmps	r14, r12 wz,wc
 434 0360 1800D484 		IF_NE	brs	#.L17
  73:RAM_Test.c    ****   end = CNT;          // Stop timing read byte
 435              		.loc 1 73 0
 436 0364 0000BCA0 		mov	r12, CNT
 437              	.LVL86
  74:RAM_Test.c    ****   close_read(); 
 438              		.loc 1 74 0
 439 0368 00007C5C 		lcall	#_close_read
 439      00000000 
  76:RAM_Test.c    ****   print("%d random byte reads per second\n", CLKFREQ / ((end-start) / 32768)); 
 440              		.loc 1 76 0
 441 0370 0000BCA0 		mov	r0, r12
 442 0374 00007C5C 		mvi	r7,#.LC2
 442      00000000 
 443 037c 0000BCA0 		mov	r1, r14
 444 0380 0000BC84 		sub	r0, r13
 445 0384 0000FC5C 		call	#__DIVSI
 446 0388 00003C08 		wrlong	r7, sp
 447 038c 00007C5C 		mvi	r7,#__clkfreq
 447      00000000 
 448 0394 0000BCA0 		mov	r1, r0
 449 0398 0000BC08 		rdlong	r0, r7
 450 039c 0000BCA0 		mov	r7, sp
 451 03a0 0400FC80 		add	r7, #4
 452 03a4 0000FC5C 		call	#__UDIVSI
 453 03a8 00003C08 		wrlong	r0, r7
  79:RAM_Test.c    ****     j=0;
 454              		.loc 1 79 0
 455 03ac 0000FCA0 		mov	r14, #0
 456              	.LVL87
  76:RAM_Test.c    ****   print("%d random byte reads per second\n", CLKFREQ / ((end-start) / 32768)); 
 457              		.loc 1 76 0
 458 03b0 00007C5C 		lcall	#_print
 458      00000000 
 459              	.LVL88
  80:RAM_Test.c    ****     open_read();      // Open read
 460              		.loc 1 80 0
 461 03b8 00007C5C 		lcall	#_open_read
 461      00000000 
  81:RAM_Test.c    ****     start = CNT;      // Start timing read row
 462              		.loc 1 81 0
 463 03c0 0000BCA0 		mov	r12, CNT
 464              	.LVL89
 465              	.L18
  83:RAM_Test.c    ****       read_row(data, j);  // Read row
 466              		.loc 1 83 0
 467 03c4 0000BCA0 		mov	r0, sp
 468 03c8 0000BCA0 		mov	r1, r14
 469 03cc 0C00FC80 		add	r0, #12
  84:RAM_Test.c    ****       j++;
 470              		.loc 1 84 0
 471 03d0 0100FC80 		add	r14, #1
  83:RAM_Test.c    ****       read_row(data, j);  // Read row
 472              		.loc 1 83 0
 473 03d4 00007C5C 		lcall	#_read_row
 473      00000000 
 474              	.LVL90
  82:RAM_Test.c    ****     while(j < 64) {
 475              		.loc 1 82 0
 476 03dc 40007CC3 		cmps	r14, #64 wz,wc
 477 03e0 2000D484 		IF_NE	brs	#.L18
  92:RAM_Test.c    ****     print("%d\n", ((uint8_t *)(data))[j]);
 478              		.loc 1 92 0
 479 03e4 0000BCA0 		mov	r13, sp
  86:RAM_Test.c    ****     end = CNT;        // Stop timing read row
 480              		.loc 1 86 0
 481 03e8 0000BCA0 		mov	r11, CNT
 482              	.LVL91
  90:RAM_Test.c    ****   j = 0;
 483              		.loc 1 90 0
 484 03ec 0000FCA0 		mov	r14, #0
 485              	.LVL92
  92:RAM_Test.c    ****     print("%d\n", ((uint8_t *)(data))[j]);
 486              		.loc 1 92 0
 487 03f0 0400FC80 		add	r13, #4
  87:RAM_Test.c    ****     close_read();     // Close read
 488              		.loc 1 87 0
 489 03f4 00007C5C 		lcall	#_close_read
 489      00000000 
 490              	.LVL93
 491              	.L19
  39:RAM_Test.c    **** int main() {                  // Entry point
 492              		.loc 1 39 0
 493 03fc 0C00FCA0 		mov	r7, #12
  92:RAM_Test.c    ****     print("%d\n", ((uint8_t *)(data))[j]);
 494              		.loc 1 92 0
 495 0400 00007C5C 		mvi	r5,#.LC3
 495      00000000 
  39:RAM_Test.c    **** int main() {                  // Entry point
 496              		.loc 1 39 0
 497 0408 0000BC80 		add	r7, sp
 498 040c 0000BC80 		add	r7, r14
  93:RAM_Test.c    ****     j++;
 499              		.loc 1 93 0
 500 0410 0100FC80 		add	r14, #1
  92:RAM_Test.c    ****     print("%d\n", ((uint8_t *)(data))[j]);
 501              		.loc 1 92 0
 502 0414 00003C08 		wrlong	r5, sp
 503 0418 0000BC00 		rdbyte	r7, r7
 504 041c 00003C08 		wrlong	r7, r13
 505 0420 00007C5C 		lcall	#_print
 505      00000000 
 506              	.LVL94
  91:RAM_Test.c    ****   while(j < 64) {
 507              		.loc 1 91 0
 508 0428 40007CC3 		cmps	r14, #64 wz,wc
 509 042c 3400D484 		IF_NE	brs	#.L19
  96:RAM_Test.c    ****   print("%d sequential byte reads per second\n", CLKFREQ / ((end-start) / 4096));    
 510              		.loc 1 96 0
 511 0430 0000BCA0 		mov	r0, r11
 512 0434 00007C5C 		mvi	r7,#.LC4
 512      00000000 
 513 043c 0000BC84 		sub	r0, r12
 514 0440 00007C5C 		mvi	r1,#4096
 514      00100000 
 515 0448 0000FC5C 		call	#__DIVSI
 516 044c 00003C08 		wrlong	r7, sp
 517 0450 00007C5C 		mvi	r7,#__clkfreq
 517      00000000 
 518 0458 0000BCA0 		mov	r1, r0
 519 045c 0000BC08 		rdlong	r0, r7
 520 0460 0000FC5C 		call	#__UDIVSI
 521 0464 00003C08 		wrlong	r0, r13
 522 0468 00007C5C 		lcall	#_print
 522      00000000 
  98:RAM_Test.c    **** }
 523              		.loc 1 98 0
 524 0470 0000FCA0 		mov	r0, #0
 525 0474 0C01FC80 		add	sp, #268
 526 0478 5F00FCA0 		mov	__TMP0,#(5<<4)+15
 527 047c 0000FC5C 		call	#__LMM_POPRET
 528              		'' never returns
 529              	.LFE1
 639              	.Letext0
 640              		.file 2 "c:\\program files (x86)\\simpleide\\propeller-gcc\\bin\\../lib/gcc/propeller-elf/4.6.1/..
 641              		.file 3 "C:/Users/mikeo/OneDrive/Documents/Calculator/SimpleIDE/Learn/Simple Libraries/TextDevices
 642              		.file 4 "c:\\program files (x86)\\simpleide\\propeller-gcc\\bin\\../lib/gcc/propeller-elf/4.6.1/..
 643              		.file 5 "c:\\program files (x86)\\simpleide\\propeller-gcc\\bin\\../lib/gcc/propeller-elf/4.6.1/..
DEFINED SYMBOLS
C:\Users\mikeo\AppData\Local\Temp\ccbBPzBk.s:5      .text:00000000 _init_RAM
C:\Users\mikeo\AppData\Local\Temp\ccbBPzBk.s:9      .text:00000000 L0
C:\Users\mikeo\AppData\Local\Temp\ccbBPzBk.s:50     .text:00000060 _open_write
C:\Users\mikeo\AppData\Local\Temp\ccbBPzBk.s:86     .text:000000a4 _close_write
C:\Users\mikeo\AppData\Local\Temp\ccbBPzBk.s:114    .text:000000d4 _write_byte
C:\Users\mikeo\AppData\Local\Temp\ccbBPzBk.s:144    .text:00000114 _open_read
C:\Users\mikeo\AppData\Local\Temp\ccbBPzBk.s:181    .text:00000160 _close_read
C:\Users\mikeo\AppData\Local\Temp\ccbBPzBk.s:210    .text:00000198 _read_byte
C:\Users\mikeo\AppData\Local\Temp\ccbBPzBk.s:237    .text:000001cc _read_row
C:\Users\mikeo\AppData\Local\Temp\ccbBPzBk.s:311    .text:00000230 _main
                            .data:00000000 .LC0
                            .data:00000024 .LC1
                            .data:0000002c .LC2
                            .data:00000050 .LC3
                            .data:00000054 .LC4
                     .debug_frame:00000000 .Lframe0
                            .text:00000000 .LFB2
                            .text:00000060 .LFB3
                            .text:000000a4 .LFB4
                            .text:000000d4 .LFB5
                            .text:00000114 .LFB6
                            .text:00000160 .LFB7
                            .text:00000198 .LFB8
                            .text:000001cc .LFB9
                            .text:00000230 .LFE9
                            .text:00000230 .LFB1
                            .text:00000480 .LFE1
                    .debug_abbrev:00000000 .Ldebug_abbrev0
                            .text:00000000 .Ltext0
                            .text:00000480 .Letext0
                      .debug_line:00000000 .Ldebug_line0
                            .text:00000060 .LFE2
                            .text:000000a4 .LFE3
                            .text:000000d4 .LFE4
                            .text:00000114 .LFE5
                       .debug_loc:00000000 .LLST0
                       .debug_loc:00000013 .LLST1
                            .text:00000160 .LFE6
                            .text:00000198 .LFE7
                            .text:000001cc .LFE8
                       .debug_loc:00000026 .LLST2
                       .debug_loc:00000039 .LLST3
                            .text:000001d4 .LBB2
                            .text:0000022c .LBE2
                       .debug_loc:00000068 .LLST4
                       .debug_loc:00000087 .LLST5
                       .debug_loc:000000b4 .LLST6
                       .debug_loc:00000123 .LLST7
                       .debug_loc:0000014c .LLST8
                       .debug_str:00000000 .LASF0
                      .debug_info:00000000 .Ldebug_info0

UNDEFINED SYMBOLS
r7
DIRA
__LMM_MVI_r6
r6
OUTA
pc
lr
r1
r0
INA
__LMM_MVI_r3
__LMM_MVI_r4
__LMM_FCACHE_LOAD
r5
r3
r4
__LMM_FCACHE_START
__LMM_RET
__TMP0
__LMM_PUSHM
__LMM_PUSHM_ret
sp
__LMM_CALL
r13
CNT
r14
__LMM_MVI_r12
r12
__LMM_MVI_r7
__DIVSI
__DIVSI_ret
__clkfreq
__UDIVSI
__UDIVSI_ret
_print
__LMM_MVI_r5
r11
__LMM_MVI_r1
__LMM_POPRET
__LMM_POPRET_ret
